package com.crm.ucard.dao.repository;

import com.crm.rely.backend.core.pojo.table.ucard.CardGlobalOrderTable;
import com.crm.rely.backend.dao.repository.BaseRepository;
import org.springframework.data.jpa.repository.Lock;
import org.springframework.stereotype.Repository;

import javax.persistence.LockModeType;

@Repository
public interface CardGlobalOrderRepository extends BaseRepository<CardGlobalOrderTable> {

    @Lock(LockModeType.PESSIMISTIC_WRITE)
    CardGlobalOrderTable findByDeductionMerchantOrderNo(String deductionMerchantOrderNo);

    @Lock(LockModeType.PESSIMISTIC_WRITE)
    CardGlobalOrderTable findFirstById(Long id);

    CardGlobalOrderTable getFirstById(Long id);

    @Lock(LockModeType.PESSIMISTIC_WRITE)
    CardGlobalOrderTable findByRefundMerchantOrderNo(String refundMerchantOrderNo);

    @Lock(LockModeType.PESSIMISTIC_WRITE)
    CardGlobalOrderTable findByOrderNo(String orderNo);
}
